Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QImage

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.gui.QImage

All Implemented Interfaces:
  QPaintDeviceInterface, QtJambiInterface, java.lang.Cloneable

    public class QImage

extends QtJambiObject
implements QPaintDeviceInterface, java.lang.Cloneable

The QImage class provides a hardware-independent image representation that allows direct access to the pixel data, and can be used as a paint device. Qt provides four classes for handling image data: QImage, `QPixmap`, `QBitmap` and `QPicture`. QImage is designed and optimized for I/O, and for direct pixel access and manipulation, while `QPixmap` is designed and optimized for showing images on screen. `QBitmap` is only a convenience class that inherits `QPixmap`, ensuring a depth of 1. Finally, the `QPicture` class is a paint device that records and replays `QPainter` commands.

Because QImage is a `QPaintDevice` subclass, `QPainter` can be used to draw directly onto images. When using `QPainter` on a QImage, the painting can be performed in another thread than the current GUI thread.

The QImage class supports several image formats described by the `Format` enum. These include monochrome, 8-bit, 32-bit and alpha-blended images which are available in all versions of Qt 4.x.

QImage provides a collection of functions that can be used to obtain a variety of information about the image. There are also several functions that enables transformation of the image.

QImage objects can be passed around by value since the QImage class uses implicit data sharing. QImage objects can also be streamed and compared.

Note: If you would like to load QImage objects in a static build of Qt, refer to the Plugin HowTo.

- Reading and Writing Image Files
- Image Information
- Pixel Manipulation
- Image Formats
- Image Transformations
- Legal Information

## Reading and Writing Image Files

QImage provides several ways of loading an image file: The file can be loaded when constructing the QImage object, or by using the `load()` or `loadFromData()` functions later on. QImage also provides the static `fromData()` function, constructing a QImage from the given data. When loading an image, the file name can either refer to an actual file on disk or to one of the application's embedded resources. See The Qt Resource System overview for details on how to embed images and other resource files in the application's executable.

Simply call the `save()` function to save a QImage object.

The complete list of supported file formats are available through the `QImageReader::supportedImageFormats()` and `QImageWriter::supportedImageFormats()` functions. New file formats can be added as plugins. By default, Qt supports the following formats:

Format | Description | Qt's support
--- | --- | ---
BMP | Windows Bitmap | Read/write
GIF | Graphic Interchange Format (optional) | Read
JPG | Joint Photographic Experts Group | Read/write
JPEG | Joint Photographic Experts Group | Read/write
PNG | Portable Network Graphics | Read/write
PBM | Portable Bitmap | Read
PGM | Portable Graymap | Read
PPM | Portable Pixmap | Read/write
TIFF | Tagged Image File Format | Read/write
XBM | X11 Bitmap | Read/write
XPM | X11 Pixmap | Read/write

(To configure Qt with GIF support, pass `-qt-gif` to the `configure` script or check the appropriate option in the graphical installer.)

## Image Information

QImage provides a collection of functions that can be used to obtain a variety of information about the image:

| Available Functions
--- | ---
Geometry | The `size()`, `width()`, `height()`, `dotsPerMeterX()`, and `dotsPerMeterY()` functions provide information about the image size and aspect ratio. The `rect()` function returns the image's enclosing rectangle. The `valid()` function tells if a given pair of coordinates is within this rectangle. The `offset()` function returns the number of pixels by which the image is intended to be offset by when positioned relative to other images, which also can be manipulated using the `setOffset()` function.
Colors | The color of a pixel can be retrieved by passing its coordinates to the `pixel()` function. The `pixel()` function returns the color as a QRgb value indepedent of the image's format. In case of monochrome and 8-bit images, the `numColors()` and `colorTable()` functions provide information about the color components used to store the image data: The `colorTable()` function returns the image's entire color table. To obtain a single entry, use the `pixelIndex()` function to retrieve the pixel index for a given pair of coordinates, then use the `color()` function to retrieve the color. Note that if you create an 8-bit image manually, you have to set a valid color table on the image as well. The `hasAlphaChannel()` function tells if the image's format respects the alpha channel, or not. The `allGray()` and `isGrayscale()` functions tell whether an image's colors are all shades of gray. See also the Pixel Manipulation and Image Transformations sections.
Text | The `text()` function returns the image text associated with the given text key. An image's text keys can be retrieved using the `textKeys()` function. Use the `setText()` function to alter an image's text.
Low-level information | The `depth()` function returns the depth of the image. The supported depths are 1 (monochrome), 8 and 32 (for more information see the Image Formats section). The `format()`, `bytesPerLine()`, and `numBytes()` functions provide low-level information about the data stored in the image. The `cacheKey()` function returns a number that uniquely identifies the contents of this QImage object.

## Pixel Manipulation

The functions used to manipulate an image's pixels depend on the image format. The reason is that monochrome and 8-bit images are index-based and use a color lookup table, while 32-bit images store ARGB values directly. For more information on image formats, see the Image Formats section.

In case of a 32-bit image, the `setPixel()` function can be used to alter the color of the pixel at the given coordinates to any other color specified as an ARGB quadruplet. To make a suitable QRgb value, use the qRgb() (adding a default alpha component to the given RGB values, i.e. creating an opaque color) or qRgba() function. For example:

            QImage image = new QImage(3, 3, QImage.Format.Format_RGB32);
            int value;

            value = new QColor(189, 149, 39).rgb(); // 0xffbd9527
            image.setPixel(1, 1, value);

            value = new QColor(122, 163, 39).rgb(); // 0xff7aa327
            image.setPixel(0, 1, value);
            image.setPixel(1, 0, value);

            value = new QColor(237, 187, 51).rgb(); // 0xffedba31
            image.setPixel(2, 1, value);
32-bit

In case of a 8-bit and monchrome images, the pixel value is only an index from the image's color table. So the `setPixel()` function can only be used to alter the color of the pixel at the given coordinates to a predefined color from the image's color table, i.e. it can only change the pixel's index value. To alter or add a color to an image's color table, use the `setColor()` function.

An entry in the color table is an ARGB quadruplet encoded as an QRgb value. Use the qRgb() and qRgba() functions to make a suitable QRgb value for use with the `setColor()` function. For example:

            QImage image = new QImage(3, 3, QImage.Format.Format_Indexed8);
            int value;

            value = new QColor(122, 163, 39).rgb(); // 0xff7aa327
            image.setColor(0, value);

            value = new QColor(237, 187, 51).rgb(); // 0xffedba31
            image.setColor(1, value);

            value = new QColor(189, 149, 39).rgb(); // 0xffbd9527
            image.setColor(2, value);

            image.setPixel(0, 1, 0);
            image.setPixel(1, 0, 0);
            image.setPixel(1, 1, 2);
            image.setPixel(2, 1, 1);
8-bit

QImage also provide the `scanLine()` function which returns a pointer to the pixel data at the scanline with the given index, and the `bits()` function which returns a pointer to the first pixel data (this is equivalent to `scanLine(0)`).

## Image Formats

Each pixel stored in a QImage is represented by an integer. The size of the integer varies depending on the format. QImage supports several image formats described by the `Format` enum. The monochrome (1-bit), 8-bit and 32-bit images are available in all versions of Qt. In addition Qt for Embedded Linux also supports 2-bit, 4-bit, and 16-bit images. For more information about the Qt Extended specific formats, see the documentation of the `Format` enum.

Monochrome images are stored using 1-bit indexes into a color table with at most two colors. There are two different types of monochrome images: big endian (MSB first) or little endian (LSB first) bit order.

8-bit images are stored using 8-bit indexes into a color table, i.e. they have a single byte per pixel. The color table is a QVector<QRgb>, and the QRgb typedef is equivalent to an unsigned int containing an ARGB quadruplet on the format 0xAARRGGBB.

32-bit images have no color table; instead, each pixel contains an QRgb value. There are three different types of 32-bit images storing RGB (i.e. 0xffRRGGBB), ARGB and premultiplied ARGB values respectively. In the premultiplied format the red, green, and blue channels are multiplied by the alpha component divided by 255.

An image's format can be retrieved using the `format()` function. Use the `convertToFormat()` functions to convert an image into another format. The `allGray()` and `isGrayscale()` functions tell whether a color image can safely be converted to a grayscale image.

## Image Transformations

QImage supports a number of functions for creating a new image that is a transformed version of the original: The `createAlphaMask()` function builds and returns a 1-bpp mask from the alpha buffer in this image, and the `createHeuristicMask()` function creates and returns a 1-bpp heuristic mask for this image. The latter function works by selecting a color from one of the corners, then chipping away pixels of that color starting at all the edges.

The `mirrored()` function returns a mirror of the image in the desired direction, the `scaled()` returns a copy of the image scaled to a rectangle of the desired measures, the `rgbSwapped()` function constructs a BGR image from a RGB image, and the `alphaChannel()` function constructs an image from this image's alpha channel.

The `scaledToWidth()` and `scaledToHeight()` functions return scaled copies of the image.

The `transformed()` function returns a copy of the image that is transformed with the given transformation matrix and transformation mode: Internally, the transformation matrix is adjusted to compensate for unwanted translation, i.e. `transformed()` returns the smallest image containing all transformed points of the original image. The static `trueMatrix()` function returns the actual matrix used for transforming the image.

There are also functions for changing attributes of an image in-place:

Function | Description
--- | ---
`setAlphaChannel()` | Sets the alpha channel of the image.
`setDotsPerMeterX()` | Defines the aspect ratio by setting the number of pixels that fit horizontally in a physical meter.
`setDotsPerMeterY()` | Defines the aspect ratio by setting the number of pixels that fit vertically in a physical meter.
`fill()` | Fills the entire image with the given pixel value.
`invertPixels()` | Inverts all pixel values in the image using the given `InvertMode` value.
`setColorTable()` | Sets the color table used to translate color indexes. Only monochrome and 8-bit formats.
`setNumColors()` | Resizes the color table. Only monochrome and 8-bit formats.

## Legal Information

For smooth scaling, the `transformed()` functions use code based on smooth scaling algorithm by Daniel M. Duley.Copyright (C) 2004, 2005 Daniel M. DuleyRedistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See also:
  `QImageReader`, `QImageWriter`, `QPixmap`, `QSvgRenderer`, Image Composition Example, Image Viewer Example, Scribble Example, and Pixelator Example.

Nested Class Summary
`static class` | `QImage.Format` The following image formats are available in all versions of Qt.
`static class` | `QImage.InvertMode` This enum type is used to describe how pixel values should be inverted in the `invertPixels()` function.

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QImage()` Constructs a null image.
`QImage(byte[] data, int width, int height, QImage.Format format)` Constructs an image with the given `width`, `height`, `depth`, `bytesPerLine`, `colortable`, `numColors` and `bitOrder`, that uses an existing memory buffer, `data`.
`QImage(int width, int height, QImage.Format format)` Constructs an image with the given `width`, `height` and `format`.
`QImage(QImage arg__1)` Constructs a shallow copy of the given `image`.
`QImage(QNativePointer data, int width, int height, int bytesPerLine, QImage.Format format)` Constructs an image with the given `width`, `height` and `format`, that uses an existing memory buffer, `data`.
`QImage(QSize size, QImage.Format format)` Constructs an image with the given `size` and `format`.
`QImage(java.lang.String fileName)` Constructs an image from the given `xpm` image.
`QImage(java.lang.String[] xpm)`
`QImage(java.lang.String fileName, java.lang.String format)` Constructs an image and tries to load the image from the file with the given `fileName`.

Method Summary
`boolean` | `allGray()` Returns true if all the colors in the image are shades of gray (i.
`QImage` | `alphaChannel()` Returns the alpha channel of the image as a new grayscale QImage in which each pixel's red, green, and blue values are given the alpha value of the original image.
`QNativePointer` | `bits()` Returns a pointer to the first pixel data.
`int` | `bytesPerLine()` Returns the number of bytes per image scanline.
`long` | `cacheKey()` Returns a number that identifies the contents of this QImage object.
`QImage` | `clone()` This method is reimplemented for internal reasons
`int` | `color(int i)` Returns the color in the color table at index `i`.
`java.util.List` | `colorTable()` Returns a list of the colors contained in the image's color table, or an empty list if the image does not have a color table
`QImage` | `convertToFormat(QImage.Format f)` Returns a copy of the image in the given `format`.
`QImage` | `convertToFormat(QImage.Format f, java.util.List colorTable)` Returns a copy of the image in the given `format`.
`QImage` | `convertToFormat(QImage.Format f, java.util.List colorTable, Qt.ImageConversionFlag[] flags)`
`QImage` | `convertToFormat(QImage.Format f, java.util.List colorTable, Qt.ImageConversionFlags flags)` Returns a copy of the image in the given `format`.
`QImage` | `convertToFormat(QImage.Format f, Qt.ImageConversionFlag[] flags)`
`QImage` | `convertToFormat(QImage.Format f, Qt.ImageConversionFlags flags)` Returns a copy of the image in the given `format`.
`QImage` | `copy()` Returns a sub-area of the image as a new image.
`QImage` | `copy(int x, int y, int w, int h)` The returned image is copied from the position (`x`, `y`) in this image, and will always have the given `width` and `height`.
`QImage` | `copy(QRect rect)` Returns a sub-area of the image as a new image.
`byte[]` | `copyOfBytes()` Returns a copy of the image data.
`QImage` | `createAlphaMask()` Builds and returns a 1-bpp mask from the alpha buffer in this image.
`QImage` | `createAlphaMask(Qt.ImageConversionFlag[] flags)`
`QImage` | `createAlphaMask(Qt.ImageConversionFlags flags)` Builds and returns a 1-bpp mask from the alpha buffer in this image.
`QImage` | `createHeuristicMask()` Creates and returns a 1-bpp heuristic mask for this image.
`QImage` | `createHeuristicMask(boolean clipTight)` Creates and returns a 1-bpp heuristic mask for this image.
`QImage` | `createMaskFromColor(int color)` Creates and returns a mask for this image based on the given `color` value.
`QImage` | `createMaskFromColor(int color, Qt.MaskMode mode)` Creates and returns a mask for this image based on the given `color` value.
`int` | `depth()` Returns the bit depth (number of bit planes) of the paint device.
`int` | `dotsPerMeterX()` Returns the number of pixels that fit horizontally in a physical meter.
`int` | `dotsPerMeterY()` Returns the number of pixels that fit vertically in a physical meter.
`void` | `fill(int pixel)` Fills the entire image with the given `pixelValue`.
`QImage.Format` | `format()` Returns the format of the image.
`static QImage` | `fromData(QByteArray data)` This is an overloaded method provided for convenience.
`static QImage` | `fromData(QByteArray data, java.lang.String format)` This is an overloaded method provided for convenience.
`boolean` | `hasAlphaChannel()` Returns true if the image has a format that respects the alpha channel, otherwise returns false.
`int` | `height()` Returns the height of the paint device in default coordinate system units (e.
`int` | `heightMM()` Returns the height of the paint device in millimeters.
`void` | `invertPixels()` Inverts all pixel values in the image.
`void` | `invertPixels(QImage.InvertMode arg__1)` Inverts all pixel values in the image.
`boolean` | `isGrayscale()` For 32-bit images, this function is equivalent to `allGray()`.
`boolean` | `isNull()` Returns true if it is a null image, otherwise returns false.
`boolean` | `load(QIODevice device)` This is an overloaded method provided for convenience.
`boolean` | `load(QIODevice device, java.lang.String format)` This is an overloaded function provided for convenience.
`boolean` | `load(java.lang.String fileName)` This is an overloaded method provided for convenience.
`boolean` | `load(java.lang.String fileName, java.lang.String format)` Loads an image from the file with the given `fileName`.
`boolean` | `loadFromData(byte[] data)` Loads an image from the given `QByteArray` `data`.
`boolean` | `loadFromData(byte[] data, java.lang.String format)` Loads an image from the given `QByteArray` `data`.
`boolean` | `loadFromData(QByteArray data)` This is an overloaded method provided for convenience.
`boolean` | `loadFromData(QByteArray data, java.lang.String format)` This is an overloaded method provided for convenience.
`int` | `logicalDpiX()` Returns the horizontal resolution of the device in dots per inch, which is used when computing font sizes.
`int` | `logicalDpiY()` Returns the vertical resolution of the device in dots per inch, which is used when computing font sizes.
`int` | `metric(QPaintDevice.PaintDeviceMetric metric)` Returns the metric information for the given paint device `metric`.
`QImage` | `mirrored()` Returns a mirror of the image, mirrored in the horizontal and/or the vertical direction depending on whether `horizontal` and `vertical` are set to true or false.
`QImage` | `mirrored(boolean horizontally)` Returns a mirror of the image, mirrored in the horizontal and/or the vertical direction depending on whether `horizontal` and `vertical` are set to true or false.
`QImage` | `mirrored(boolean horizontally, boolean vertically)` Returns a mirror of the image, mirrored in the horizontal and/or the vertical direction depending on whether `horizontal` and `vertical` are set to true or false.
`int` | `numBytes()` Returns the number of bytes occupied by the image data.
`int` | `numColors()` Returns the number of different colors available for the paint device.
`QPoint` | `offset()` Returns the number of pixels by which the image is intended to be offset by when positioning relative to other images.
`QPaintEngine` | `paintEngine()` Returns a pointer to the paint engine used for drawing on the device.
`boolean` | `paintingActive()` Returns true if the device is currently being painted on, i.
`int` | `physicalDpiX()` Returns the horizontal resolution of the device in dots per inch.
`int` | `physicalDpiY()` Returns the horizontal resolution of the device in dots per inch.
`int` | `pixel(int x, int y)` Returns the color of the pixel at coordinates (`x`, `y`).
`int` | `pixel(QPoint pt)` Returns the color of the pixel at the given `position`.
`int` | `pixelIndex(int x, int y)` Returns the pixel index at (`x`, `y`).
`int` | `pixelIndex(QPoint pt)` Returns the pixel index at the given `position`.
`void` | `readFrom(QDataStream arg__1)` Reads a QImage
`QRect` | `rect()` Returns the enclosing rectangle (0, 0, `width()`, `height()`) of the image.
`QImage` | `rgbSwapped()` Returns a QImage in which the values of the red and blue components of all pixels have been swapped, effectively converting an RGB image to an BGR image.
`boolean` | `save(QIODevice dev)` This is an overloaded function provided for convenience.
`boolean` | `save(QIODevice dev, java.lang.String format)` This is an overloaded method provided for convenience.
`boolean` | `save(QIODevice dev, java.lang.String format, int quality)` This is an overloaded method provided for convenience.
`boolean` | `save(java.lang.String fileName)` This is an overloaded method provided for convenience.
`boolean` | `save(java.lang.String fileName, java.lang.String format)` This is an overloaded method provided for convenience.
`boolean` | `save(java.lang.String fileName, java.lang.String format, int quality)` Saves the image to the file with the given `fileName`, using the given image file `format` and `quality` factor.
`QImage` | `scaled(int w, int h)` Returns a copy of the image scaled to a rectangle with the given `width` and `height` according to the given `aspectRatioMode` and `transformMode`.
`QImage` | `scaled(int w, int h, Qt.AspectRatioMode aspectMode)` Returns a copy of the image scaled to a rectangle with the given `width` and `height` according to the given `aspectRatioMode` and `transformMode`.
`QImage` | `scaled(int w, int h, Qt.AspectRatioMode aspectMode, Qt.TransformationMode mode)` Returns a copy of the image scaled to a rectangle with the given `width` and `height` according to the given `aspectRatioMode` and `transformMode`.
`QImage` | `scaled(QSize s)` Returns a copy of the image scaled to a rectangle defined by the given `size` according to the given `aspectRatioMode` and `transformMode`.
`QImage` | `scaled(QSize s, Qt.AspectRatioMode aspectMode)` Returns a copy of the image scaled to a rectangle defined by the given `size` according to the given `aspectRatioMode` and `transformMode`.
`QImage` | `scaled(QSize s, Qt.AspectRatioMode aspectMode, Qt.TransformationMode mode)` Returns a copy of the image scaled to a rectangle defined by the given `size` according to the given `aspectRatioMode` and `transformMode`.
`QImage` | `scaledToHeight(int h)` Returns a scaled copy of the image.
`QImage` | `scaledToHeight(int h, Qt.TransformationMode mode)` Returns a scaled copy of the image.
`QImage` | `scaledToWidth(int w)` Returns a scaled copy of the image.
`QImage` | `scaledToWidth(int w, Qt.TransformationMode mode)` Returns a scaled copy of the image.
`QNativePointer` | `scanLine(int arg__1)` Returns a pointer to the pixel data at the scanline with index `i`.
`void` | `setAlphaChannel(QImage alphaChannel)` Sets the alpha channel of this image to the given `alphaChannel`.
`void` | `setColor(int i, int c)` Sets the color at the given `index` in the color table, to the given to `colorValue`.
`void` | `setColorTable(java.util.List colors)` Sets the color table used to translate color indexes to QRgb values, to the specified `colors`.
`void` | `setDotsPerMeterX(int arg__1)` Sets the number of pixels that fit horizontally in a physical meter, to `x`.
`void` | `setDotsPerMeterY(int arg__1)` Sets the number of pixels that fit vertically in a physical meter, to `y`.
`void` | `setNumColors(int arg__1)` Resizes the color table to contain `numColors` entries.
`void` | `setOffset(QPoint arg__1)` Sets the the number of pixels by which the image is intended to be offset by when positioning relative to other images, to `offset`.
`void` | `setPixel(int x, int y, int index_or_rgb)` Sets the pixel index or color at (`x`, `y`) to `index_or_rgb`.
`void` | `setPixel(QPoint pt, int index_or_rgb)` Sets the pixel index or color at the given `position` to `index_or_rgb`.
`void` | `setText(java.lang.String key, java.lang.String value)` Sets the image text to the given `text` and associate it with the given `key`.
`QSize` | `size()` Returns the size of the image, i.
`java.lang.String` | `text()` Returns the image text associated with the given `key`.
`java.lang.String` | `text(java.lang.String key)` Returns the image text associated with the given `key`.
`java.util.List` | `textKeys()` Returns the text keys for this image.
`QImage` | `transformed(QMatrix matrix)` Returns a copy of the image that is transformed using the given transformation `matrix` and transformation `mode`.
`QImage` | `transformed(QMatrix matrix, Qt.TransformationMode mode)` Returns a copy of the image that is transformed using the given transformation `matrix` and transformation `mode`.
`QImage` | `transformed(QTransform matrix)` Returns a copy of the image that is transformed using the given transformation `matrix` and transformation `mode`.
`QImage` | `transformed(QTransform matrix, Qt.TransformationMode mode)` Returns a copy of the image that is transformed using the given transformation `matrix` and transformation `mode`.
`static QMatrix` | `trueMatrix(QMatrix arg__1, int w, int h)` Returns the actual matrix used for transforming an image with the given `width`, `height` and `matrix`.
`static QTransform` | `trueMatrix(QTransform arg__1, int w, int h)` Returns the actual matrix used for transforming an image with the given `width`, `height` and `matrix`.
`boolean` | `valid(int x, int y)` Returns true if `QPoint`(`x`, `y`) is a valid coordinate pair within the image; otherwise returns false.
`boolean` | `valid(QPoint pt)` Returns true if `pos` is a valid coordinate pair within the image; otherwise returns false.
`int` | `width()` Returns the width of the paint device in default coordinate system units (e.
`int` | `widthMM()` Returns the width of the paint device in millimeters.
`void` | `writeTo(QDataStream arg__1)` Writes thisQImage

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QImage

    public QImage()

  Constructs a null image.

See also:
  `isNull()`.

### QImage

    public QImage(QImage arg__1)

  Constructs a shallow copy of the given `image`.

  For more information about shallow copies, see the Implicit Data Sharing documentation.

See also:
  `copy()`.

### QImage

    public QImage(QSize size,
                  QImage.Format format)

  Constructs an image with the given `size` and `format`.

  Warning: This will create a QImage with uninitialized data. Call `fill()` to fill the image with an appropriate pixel value before drawing onto it with `QPainter`.

### QImage

    public QImage(int width,
                  int height,
                  QImage.Format format)

  Constructs an image with the given `width`, `height` and `format`.

  Warning: This will create a QImage with uninitialized data. Call `fill()` to fill the image with an appropriate pixel value before drawing onto it with `QPainter`.

### QImage

    public QImage(QNativePointer data,
                  int width,
                  int height,
                  int bytesPerLine,
                  QImage.Format format)

  Constructs an image with the given `width`, `height` and `format`, that uses an existing memory buffer, `data`. The `width` and `height` must be specified in pixels. `bytesPerLine` specifies the number of bytes per line (stride).

  The buffer must remain valid throughout the life of the QImage. The image does not delete the buffer at destruction.

  If `format` is an indexed color format, the image color table is initially empty and must be sufficiently expanded with `setNumColors()` or `setColorTable()` before the image is used.

### QImage

    public QImage(java.lang.String[] xpm)

### QImage

    public QImage(byte[] data,
                  int width,
                  int height,
                  QImage.Format format)

  Constructs an image with the given `width`, `height`, `depth`, `bytesPerLine`, `colortable`, `numColors` and `bitOrder`, that uses an existing memory buffer, `data`. The image does not delete the buffer at destruction.

  Warning: This constructor is only available in Qt for Embedded Linux.

  The data has to be 32-bit aligned, and each scanline of data in the image must also be 32-bit aligned, so it's no longer possible to specify a custom `bytesPerLine` value.

### QImage

    public QImage(java.lang.String fileName,
                  java.lang.String format)

  Constructs an image and tries to load the image from the file with the given `fileName`.

  The loader attempts to read the image using the specified `format`. If the `format` is not specified (which is the default), the loader probes the file for a header to guess the file format.

  If the loading of the image failed, this object is a null image.

  The file name can either refer to an actual file on disk or to one of the application's embedded resources. See the \l{resources.html}{Resource System} overview for details on how to embed images and other resource files in the application's executable.

### QImage

    public QImage(java.lang.String fileName)

  Constructs an image from the given `xpm` image.

  Make sure that the image is a valid XPM image. Errors are silently ignored.

  Note that it's possible to squeeze the XPM variable a little bit by using an unusual declaration:

              String start_xpm[] = {
                  "16 15 8 1",
                  "a c #cec6bd",
                  .... };

  The extra `const` makes the entire definition read-only, which is slightly more efficient (e.g., when the code is in a shared library) and able to be stored in ROM with the application.

Method Detail

### allGray

    public final boolean allGray()

  Returns true if all the colors in the image are shades of gray (i. . their red, green and blue components are equal); otherwise false.

  Note that this function is slow for images without color table.

See also:
  `isGrayscale()`.

### alphaChannel

    public final QImage alphaChannel()

  Returns the alpha channel of the image as a new grayscale QImage in which each pixel's red, green, and blue values are given the alpha value of the original image. The color depth of the returned image is 8-bit.

  You can see an example of use of this function in `QPixmap`'s `alphaChannel()`, which works in the same way as this function on QPixmaps.

See also:
  `setAlphaChannel()`, `hasAlphaChannel()`, `Pixmap`, and Image Transformations.

### bits

    public final QNativePointer bits()

  Returns a pointer to the first pixel data. This is equivalent to scanLine(0).

  Note that QImage uses implicit data sharing. This function performs a deep copy of the shared pixel data, thus ensuring that this QImage is the only one using the current return value.

See also:
  `scanLine()`, and `numBytes()`.

### bytesPerLine

    public final int bytesPerLine()

  Returns the number of bytes per image scanline.

  This is equivalent to `numBytes()`/ `height()`.

See also:
  `scanLine()`.

### cacheKey

    public final long cacheKey()

  Returns a number that identifies the contents of this QImage object. Distinct QImage objects can only have the same key if they refer to the same contents.

  The key will change when the image is altered.

### color

    public final int color(int i)

  Returns the color in the color table at index `i`. The first color is at index 0.

  The colors in an image's color table are specified as ARGB quadruplets (QRgb). Use the qAlpha(), qRed(), qGreen(), and qBlue() functions to get the color value components.

See also:
  `setColor()`, `pixelIndex()`, and Pixel Manipulation.

### colorTable

    public final java.util.List colorTable()

  Returns a list of the colors contained in the image's color table, or an empty list if the image does not have a color table

See also.
  `setColorTable()`, `numColors()`, and `color()`.

### convertToFormat

    public final QImage convertToFormat(QImage.Format f,
                                        Qt.ImageConversionFlag[] flags)

### convertToFormat

    public final QImage convertToFormat(QImage.Format f)

  Returns a copy of the image in the given `format`.

  The specified image conversion `flags` control how the image data is handled during the conversion process.

See also:
  Image Format.

### convertToFormat

    public final QImage convertToFormat(QImage.Format f,
                                        Qt.ImageConversionFlags flags)

  Returns a copy of the image in the given `format`.

  The specified image conversion `flags` control how the image data is handled during the conversion process.

See also:
  Image Format.

### convertToFormat

    public final QImage convertToFormat(QImage.Format f,
                                        java.util.List colorTable,
                                        Qt.ImageConversionFlag[] flags)

### convertToFormat

    public final QImage convertToFormat(QImage.Format f,
                                        java.util.List colorTable)

  Returns a copy of the image in the given `format`.

  The specified image conversion `flags` control how the image data is handled during the conversion process.

See also:
  Image Format.

### convertToFormat

    public final QImage convertToFormat(QImage.Format f,
                                        java.util.List colorTable,
                                        Qt.ImageConversionFlags flags)

  Returns a copy of the image in the given `format`.

  The specified image conversion `flags` control how the image data is handled during the conversion process.

See also:
  Image Format.

### copy

    public final QImage copy()

  Returns a sub-area of the image as a new image.

  The returned image is copied from the position (`rectangle`.x(), `rectangle`.y()) in this image, and will always have the size of the given `rectangle`.

  In areas beyond this image, pixels are set to 0. For 32-bit RGB images, this means black; for 32-bit ARGB images, this means transparent black; for 8-bit images, this means the color with index 0 in the color table which can be anything; for 1-bit images, this means `Qt::color0` .

  If the given `rectangle` is a null rectangle the entire image is copied.

See also:
  QImage().

### copy

    public final QImage copy(QRect rect)

  Returns a sub-area of the image as a new image.

  The returned image is copied from the position (`rectangle`.x(), `rectangle`.y()) in this image, and will always have the size of the given `rectangle`.

  In areas beyond this image, pixels are set to 0. For 32-bit RGB images, this means black; for 32-bit ARGB images, this means transparent black; for 8-bit images, this means the color with index 0 in the color table which can be anything; for 1-bit images, this means `Qt::color0` .

  If the given `rectangle` is a null rectangle the entire image is copied.

See also:
  QImage().

### copy

    public final QImage copy(int x,
                             int y,
                             int w,
                             int h)

  The returned image is copied from the position (`x`, `y`) in this image, and will always have the given `width` and `height`. In areas beyond this image, pixels are set to 0.

### createAlphaMask

    public final QImage createAlphaMask(Qt.ImageConversionFlag[] flags)

### createAlphaMask

    public final QImage createAlphaMask()

  Builds and returns a 1-bpp mask from the alpha buffer in this image. Returns a null image if the image's format is `QImage::Format_RGB32` .

  The `flags` argument is a bitwise-OR of the Qt::ImageConversionFlags, and controls the conversion process. Passing 0 for flags sets all the default options.

  The returned image has little-endian bit order (i.e. the image's format is `QImage::Format_MonoLSB` ), which you can convert to big-endian (`QImage::Format_Mono` ) using the `convertToFormat()` function.

See also:
  `createHeuristicMask()`, and Image Transformations.

### createAlphaMask

    public final QImage createAlphaMask(Qt.ImageConversionFlags flags)

  Builds and returns a 1-bpp mask from the alpha buffer in this image. Returns a null image if the image's format is `QImage::Format_RGB32` .

  The `flags` argument is a bitwise-OR of the Qt::ImageConversionFlags, and controls the conversion process. Passing 0 for flags sets all the default options.

  The returned image has little-endian bit order (i.e. the image's format is `QImage::Format_MonoLSB` ), which you can convert to big-endian (`QImage::Format_Mono` ) using the `convertToFormat()` function.

See also:
  `createHeuristicMask()`, and Image Transformations.

### createHeuristicMask

    public final QImage createHeuristicMask()

  Creates and returns a 1-bpp heuristic mask for this image.

  The function works by selecting a color from one of the corners, then chipping away pixels of that color starting at all the edges. The four corners vote for which color is to be masked away. In case of a draw (this generally means that this function is not applicable to the image), the result is arbitrary.

  The returned image has little-endian bit order (i.e. the image's format is `QImage::Format_MonoLSB` ), which you can convert to big-endian (`QImage::Format_Mono` ) using the `convertToFormat()` function.

  If `clipTight` is true (the default) the mask is just large enough to cover the pixels; otherwise, the mask is larger than the data pixels.

  Note that this function disregards the alpha buffer.

See also:
  `createAlphaMask()`, and Image Transformations.

### createHeuristicMask

    public final QImage createHeuristicMask(boolean clipTight)

  Creates and returns a 1-bpp heuristic mask for this image.

  The function works by selecting a color from one of the corners, then chipping away pixels of that color starting at all the edges. The four corners vote for which color is to be masked away. In case of a draw (this generally means that this function is not applicable to the image), the result is arbitrary.

  The returned image has little-endian bit order (i.e. the image's format is `QImage::Format_MonoLSB` ), which you can convert to big-endian (`QImage::Format_Mono` ) using the `convertToFormat()` function.

  If `clipTight` is true (the default) the mask is just large enough to cover the pixels; otherwise, the mask is larger than the data pixels.

  Note that this function disregards the alpha buffer.

See also:
  `createAlphaMask()`, and Image Transformations.

### createMaskFromColor

    public final QImage createMaskFromColor(int color)

  Creates and returns a mask for this image based on the given `color` value. If the `mode` is MaskInColor (the default value), all pixels matching `color` will be opaque pixels in the mask. If `mode` is MaskOutColor, all pixels matching the given color will be transparent.

See also:
  `createAlphaMask()`, and `createHeuristicMask()`.

### createMaskFromColor

    public final QImage createMaskFromColor(int color,
                                            Qt.MaskMode mode)

  Creates and returns a mask for this image based on the given `color` value. If the `mode` is MaskInColor (the default value), all pixels matching `color` will be opaque pixels in the mask. If `mode` is MaskOutColor, all pixels matching the given color will be transparent.

See also:
  `createAlphaMask()`, and `createHeuristicMask()`.

### depth

    public final int depth()

  Returns the bit depth (number of bit planes) of the paint device.

  Specified by:
    `depth` in interface `QPaintDeviceInterface`

### dotsPerMeterX

    public final int dotsPerMeterX()

  Returns the number of pixels that fit horizontally in a physical meter. Together with `dotsPerMeterY()`, this number defines the intended scale and aspect ratio of the image.

See also:
  `setDotsPerMeterX()`, and Image Information.

### dotsPerMeterY

    public final int dotsPerMeterY()

  Returns the number of pixels that fit vertically in a physical meter. Together with `dotsPerMeterX()`, this number defines the intended scale and aspect ratio of the image.

See also:
  `setDotsPerMeterY()`, and Image Information.

### fill

    public final void fill(int pixel)

  Fills the entire image with the given `pixelValue`.

  If the depth of this image is 1, only the lowest bit is used. If you say fill(0), fill(2), etc., the image is filled with 0s. If you say fill(1), fill(3), etc., the image is filled with 1s. If the depth is 8, the lowest 8 bits are used and if the depth is 16 the lowest 16 bits are used.

  Note: `QImage::pixel()` returns the color of the pixel at the given coordinates while QColor::pixel() returns the pixel value of the underlying window system (essentially an index value), so normally you will want to use `QImage::pixel()` to use a color from an existing image or `QColor::rgb()` to use a specific color.

See also:
  `depth()`, and Image Transformations.

### format

    public final QImage.Format format()

  Returns the format of the image.

See also:
  Image Formats.

### hasAlphaChannel

    public final boolean hasAlphaChannel()

  Returns true if the image has a format that respects the alpha channel, otherwise returns false.

See also:
  `alphaChannel()`, and Image Information.

### height

    public final int height()

  Returns the height of the paint device in default coordinate system units (e. . pixels for `QPixmap` and `QWidget`).

See also:
  `heightMM()`.

  Specified by:
    `height` in interface `QPaintDeviceInterface`

### heightMM

    public final int heightMM()

  Returns the height of the paint device in millimeters.

See also:
  `height()`.

  Specified by:
    `heightMM` in interface `QPaintDeviceInterface`

### invertPixels

    public final void invertPixels()

  Inverts all pixel values in the image.

  The given invert `mode` only have a meaning when the image's depth is 32. The default `mode` is `InvertRgb` , which leaves the alpha channel unchanged. If the `mode` is `InvertRgba` , the alpha bits are also inverted.

  Inverting an 8-bit image means to replace all pixels using color index i with a pixel using color index 255 minus i. The same is the case for a 1-bit image. Note that the color table is not changed.

See also:
  Image Transformations.

### invertPixels

    public final void invertPixels(QImage.InvertMode arg__1)

  Inverts all pixel values in the image.

  The given invert `mode` only have a meaning when the image's depth is 32. The default `mode` is `InvertRgb` , which leaves the alpha channel unchanged. If the `mode` is `InvertRgba` , the alpha bits are also inverted.

  Inverting an 8-bit image means to replace all pixels using color index i with a pixel using color index 255 minus i. The same is the case for a 1-bit image. Note that the color table is not changed.

See also:
  Image Transformations.

### isGrayscale

    public final boolean isGrayscale()

  For 32-bit images, this function is equivalent to `allGray()`.

  For 8-bpp images, this function returns true if color(i) is QRgb(i, i, i) for all indexes of the color table; otherwise returns false.

See also:
  `allGray()`, and Image Formats.

### isNull

    public final boolean isNull()

  Returns true if it is a null image, otherwise returns false.

  A null image has all parameters set to zero and no allocated data.

### logicalDpiX

    public final int logicalDpiX()

  Returns the horizontal resolution of the device in dots per inch, which is used when computing font sizes. For X11, this is usually the same as could be computed from `widthMM()`.

  Note that if the `logicalDpiX()` doesn't equal the `physicalDpiX()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `logicalDpiY()`, and `physicalDpiX()`.

  Specified by:
    `logicalDpiX` in interface `QPaintDeviceInterface`

### logicalDpiY

    public final int logicalDpiY()

  Returns the vertical resolution of the device in dots per inch, which is used when computing font sizes. For X11, this is usually the same as could be computed from `heightMM()`.

  Note that if the `logicalDpiY()` doesn't equal the `physicalDpiY()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `logicalDpiX()`, and `physicalDpiY()`.

  Specified by:
    `logicalDpiY` in interface `QPaintDeviceInterface`

### mirrored

    public final QImage mirrored(boolean horizontally)

  Returns a mirror of the image, mirrored in the horizontal and/or the vertical direction depending on whether `horizontal` and `vertical` are set to true or false.

  Note that the original image is not changed.

See also:
  Image Transformations.

### mirrored

    public final QImage mirrored()

  Returns a mirror of the image, mirrored in the horizontal and/or the vertical direction depending on whether `horizontal` and `vertical` are set to true or false.

  Note that the original image is not changed.

See also:
  Image Transformations.

### mirrored

    public final QImage mirrored(boolean horizontally,
                                 boolean vertically)

  Returns a mirror of the image, mirrored in the horizontal and/or the vertical direction depending on whether `horizontal` and `vertical` are set to true or false.

  Note that the original image is not changed.

See also:
  Image Transformations.

### numBytes

    public final int numBytes()

  Returns the number of bytes occupied by the image data.

See also:
  `bytesPerLine()`, `bits()`, and Image Information.

### numColors

    public final int numColors()

  Returns the number of different colors available for the paint device. Since this value is an int, it will not be sufficient to represent the number of colors on 32 bit displays, in this case INT_MAX is returned instead.

  Specified by:
    `numColors` in interface `QPaintDeviceInterface`

### offset

    public final QPoint offset()

  Returns the number of pixels by which the image is intended to be offset by when positioning relative to other images.

See also:
  `setOffset()`, and Image Information.

### writeTo

    public final void writeTo(QDataStream arg__1)

  Writes thisQImage

### readFrom

    public final void readFrom(QDataStream arg__1)

  Reads a QImage

### paintingActive

    public final boolean paintingActive()

  Returns true if the device is currently being painted on, i. . someone has called `QPainter::begin()` but not yet called `QPainter::end()` for this device; otherwise returns false.

See also:
  `QPainter::isActive()`.

  Specified by:
    `paintingActive` in interface `QPaintDeviceInterface`

### physicalDpiX

    public final int physicalDpiX()

  Returns the horizontal resolution of the device in dots per inch. For example, when printing, this resolution refers to the physical printer's resolution. The logical DPI on the other hand, refers to the resolution used by the actual paint engine.

  Note that if the `physicalDpiX()` doesn't equal the `logicalDpiX()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `physicalDpiY()`, and `logicalDpiX()`.

  Specified by:
    `physicalDpiX` in interface `QPaintDeviceInterface`

### physicalDpiY

    public final int physicalDpiY()

  Returns the horizontal resolution of the device in dots per inch. For example, when printing, this resolution refers to the physical printer's resolution. The logical DPI on the other hand, refers to the resolution used by the actual paint engine.

  Note that if the `physicalDpiY()` doesn't equal the `logicalDpiY()`, the corresponding `QPaintEngine` must handle the resolution mapping.

See also:
  `physicalDpiX()`, and `logicalDpiY()`.

  Specified by:
    `physicalDpiY` in interface `QPaintDeviceInterface`

### pixel

    public final int pixel(QPoint pt)

  Returns the color of the pixel at the given `position`.

  If the `position` is not valid, the results are undefined.

See also:
  `setPixel()`, `valid()`, and Pixel Manipulation.

### pixel

    public final int pixel(int x,
                           int y)

  Returns the color of the pixel at coordinates (`x`, `y`).

### pixelIndex

    public final int pixelIndex(QPoint pt)

  Returns the pixel index at the given `position`.

  If `position` is not valid, or if the image is not a paletted image (`depth()` > 8), the results are undefined.

See also:
  `valid()`, `depth()`, and Pixel Manipulation.

### pixelIndex

    public final int pixelIndex(int x,
                                int y)

  Returns the pixel index at (`x`, `y`).

### rect

    public final QRect rect()

  Returns the enclosing rectangle (0, 0, `width()`, `height()`) of the image.

See also:
  Image Information.

### rgbSwapped

    public final QImage rgbSwapped()

  Returns a QImage in which the values of the red and blue components of all pixels have been swapped, effectively converting an RGB image to an BGR image.

  The original QImage is not changed.

See also:
  Image Transformations.

### scaled

    public final QImage scaled(QSize s,
                               Qt.AspectRatioMode aspectMode)

  Returns a copy of the image scaled to a rectangle defined by the given `size` according to the given `aspectRatioMode` and `transformMode`.
  - If `aspectRatioMode` is `Qt::IgnoreAspectRatio` , the image is scaled to `size`.
  - If `aspectRatioMode` is `Qt::KeepAspectRatio` , the image is scaled to a rectangle as large as possible inside `size`, preserving the aspect ratio.
  - If `aspectRatioMode` is `Qt::KeepAspectRatioByExpanding` , the image is scaled to a rectangle as small as possible outside `size`, preserving the aspect ratio.
  If the given `size` is empty, this function returns a null image.

See also:
  `isNull()`, and Image Transformations.

### scaled

    public final QImage scaled(QSize s)

  Returns a copy of the image scaled to a rectangle defined by the given `size` according to the given `aspectRatioMode` and `transformMode`.
  - If `aspectRatioMode` is `Qt::IgnoreAspectRatio` , the image is scaled to `size`.
  - If `aspectRatioMode` is `Qt::KeepAspectRatio` , the image is scaled to a rectangle as large as possible inside `size`, preserving the aspect ratio.
  - If `aspectRatioMode` is `Qt::KeepAspectRatioByExpanding` , the image is scaled to a rectangle as small as possible outside `size`, preserving the aspect ratio.
  If the given `size` is empty, this function returns a null image.

See also:
  `isNull()`, and Image Transformations.

### scaled

    public final QImage scaled(QSize s,
                               Qt.AspectRatioMode aspectMode,
                               Qt.TransformationMode mode)

  Returns a copy of the image scaled to a rectangle defined by the given `size` according to the given `aspectRatioMode` and `transformMode`.
  - If `aspectRatioMode` is `Qt::IgnoreAspectRatio` , the image is scaled to `size`.
  - If `aspectRatioMode` is `Qt::KeepAspectRatio` , the image is scaled to a rectangle as large as possible inside `size`, preserving the aspect ratio.
  - If `aspectRatioMode` is `Qt::KeepAspectRatioByExpanding` , the image is scaled to a rectangle as small as possible outside `size`, preserving the aspect ratio.
  If the given `size` is empty, this function returns a null image.

See also:
  `isNull()`, and Image Transformations.

### scaled

    public final QImage scaled(int w,
                               int h,
                               Qt.AspectRatioMode aspectMode)

  Returns a copy of the image scaled to a rectangle with the given `width` and `height` according to the given `aspectRatioMode` and `transformMode`.

  If either the `width` or the `height` is zero or negative, this function returns a null image.

### scaled

    public final QImage scaled(int w,
                               int h)

  Returns a copy of the image scaled to a rectangle with the given `width` and `height` according to the given `aspectRatioMode` and `transformMode`.

  If either the `width` or the `height` is zero or negative, this function returns a null image.

### scaled

    public final QImage scaled(int w,
                               int h,
                               Qt.AspectRatioMode aspectMode,
                               Qt.TransformationMode mode)

  Returns a copy of the image scaled to a rectangle with the given `width` and `height` according to the given `aspectRatioMode` and `transformMode`.

  If either the `width` or the `height` is zero or negative, this function returns a null image.

### scaledToHeight

    public final QImage scaledToHeight(int h)

  Returns a scaled copy of the image. The returned image is scaled to the given `height` using the specified transformation `mode`.

  This function automatically calculates the width of the image so that the ratio of the image is preserved.

  If the given `height` is 0 or negative, a null image is returned.

See also:
  Image Transformations.

### scaledToHeight

    public final QImage scaledToHeight(int h,
                                       Qt.TransformationMode mode)

  Returns a scaled copy of the image. The returned image is scaled to the given `height` using the specified transformation `mode`.

  This function automatically calculates the width of the image so that the ratio of the image is preserved.

  If the given `height` is 0 or negative, a null image is returned.

See also:
  Image Transformations.

### scaledToWidth

    public final QImage scaledToWidth(int w)

  Returns a scaled copy of the image. The returned image is scaled to the given `width` using the specified transformation `mode`.

  This function automatically calculates the height of the image so that its aspect ratio is preserved.

  If the given `width` is 0 or negative, a null image is returned.

See also:
  Image Transformations.

### scaledToWidth

    public final QImage scaledToWidth(int w,
                                      Qt.TransformationMode mode)

  Returns a scaled copy of the image. The returned image is scaled to the given `width` using the specified transformation `mode`.

  This function automatically calculates the height of the image so that its aspect ratio is preserved.

  If the given `width` is 0 or negative, a null image is returned.

See also:
  Image Transformations.

### scanLine

    public final QNativePointer scanLine(int arg__1)

  Returns a pointer to the pixel data at the scanline with index `i`. The first scanline is at index 0.

  The scanline data is aligned on a 32-bit boundary.

  Warning: If you are accessing 32-bpp image data, cast the returned pointer to `QRgb*` (QRgb has a 32-bit size) and use it to read/write the pixel value. You cannot use the `uchar*` pointer directly, because the pixel format depends on the byte order on the underlying platform. Use qRed(), qGreen(), qBlue(), and qAlpha() to access the pixels.

See also:
  `bytesPerLine()`, `bits()`, and Pixel Manipulation.

### setAlphaChannel

    public final void setAlphaChannel(QImage alphaChannel)

  Sets the alpha channel of this image to the given `alphaChannel`.

  If `alphaChannel` is an 8 bit grayscale image, the intensity values are written into this buffer directly. Otherwise, `alphaChannel` is converted to 32 bit and the intensity of the RGB pixel values is used.

  Note that the image will be converted to the `Format_ARGB32_Premultiplied` format if the function succeeds.

See also:
  `alphaChannel()`, Image Transformations, and Image Formats.

### setColor

    public final void setColor(int i,
                               int c)

  Sets the color at the given `index` in the color table, to the given to `colorValue`. The color value is an ARGB quadruplet.

  If `index` is outside the current size of the color table, it is expanded with `setNumColors()`.

See also:
  `color()`, `numColors()`, `setColorTable()`, and Pixel Manipulation.

### setColorTable

    public final void setColorTable(java.util.List colors)

  Sets the color table used to translate color indexes to QRgb values, to the specified `colors`.

  When the image is used, the color table must be large enough to have entries for all the pixel/index values present in the image, otherwise the results are undefined.

See also:
  `colorTable()`, `setColor()`, and Image Transformations.

### setDotsPerMeterX

    public final void setDotsPerMeterX(int arg__1)

  Sets the number of pixels that fit horizontally in a physical meter, to `x`.

  Together with `dotsPerMeterY()`, this number defines the intended scale and aspect ratio of the image.

See also:
  `dotsPerMeterX()`, and Image Information.

### setDotsPerMeterY

    public final void setDotsPerMeterY(int arg__1)

  Sets the number of pixels that fit vertically in a physical meter, to `y`.

  Together with `dotsPerMeterX()`, this number defines the intended scale and aspect ratio of the image.

See also:
  `dotsPerMeterY()`, and Image Information.

### setNumColors

    public final void setNumColors(int arg__1)

  Resizes the color table to contain `numColors` entries.

  If the color table is expanded, all the extra colors will be set to transparent (i.e qRgba(0, 0, 0, 0)).

  When the image is used, the color table must be large enough to have entries for all the pixel/index values present in the image, otherwise the results are undefined.

See also:
  `numColors()`, `colorTable()`, `setColor()`, and Image Transformations.

### setOffset

    public final void setOffset(QPoint arg__1)

  Sets the the number of pixels by which the image is intended to be offset by when positioning relative to other images, to `offset`.

See also:
  `offset()`, and Image Information.

### setPixel

    public final void setPixel(QPoint pt,
                               int index_or_rgb)

  Sets the pixel index or color at the given `position` to `index_or_rgb`.

  If the image's format is either monochrome or 8-bit, the given `index_or_rgb` value must be an index in the image's color table, otherwise the parameter must be a QRgb value.

  If `position` is not a valid coordinate pair in the image, or if `index_or_rgb` >= `numColors()` in the case of monochrome and 8-bit images, the result is undefined.

  Warning: This function is expensive due to the call of the internal `detach()` function called within; if performance is a concern, we recommend the use of `scanLine()` to access pixel data directly.

See also:
  `pixel()`, and Pixel Manipulation.

### setPixel

    public final void setPixel(int x,
                               int y,
                               int index_or_rgb)

  Sets the pixel index or color at (`x`, `y`) to `index_or_rgb`.

### setText

    public final void setText(java.lang.String key,
                              java.lang.String value)

  Sets the image text to the given `text` and associate it with the given `key`.

  If you just want to store a single text block (i.e., a "comment" or just a description), you can either pass an empty key, or use a generic key like "Description".

  The image text is embedded into the image data when you call `save()` or `QImageWriter::write()`.

  Not all image formats support embedded text. You can find out if a specific image or format supports embedding text by using `QImageWriter::supportsOption()`. We give an example:

          QImageWriter writer;
          writer.setFormat("png");
          if (writer.supportsOption(QImageIOHandler::Description))
              qDebug() << "Png supports embedded text";

  You can use `QImageWriter::supportedImageFormats()` to find out which image formats are available to you.

See also:
  `text()`, and `textKeys()`.

### size

    public final QSize size()

  Returns the size of the image, i. . its `width()` and `height()`.

See also:
  Image Information.

### text

    public final java.lang.String text()

  Returns the image text associated with the given `key`. If the specified `key` is an empty string, the whole image text is returned, with each key-text pair separated by a newline.

See also:
  `setText()`, and `textKeys()`.

### text

    public final java.lang.String text(java.lang.String key)

  Returns the image text associated with the given `key`. If the specified `key` is an empty string, the whole image text is returned, with each key-text pair separated by a newline.

See also:
  `setText()`, and `textKeys()`.

### textKeys

    public final java.util.List textKeys()

  Returns the text keys for this image.

  You can use these keys with `text()` to list the image text for a certain key.

See also:
  `text()`.

### transformed

    public final QImage transformed(QMatrix matrix)

  Returns a copy of the image that is transformed using the given transformation `matrix` and transformation `mode`.

  The transformation `matrix` is internally adjusted to compensate for unwanted translation; i.e. the image produced is the smallest image that contains all the transformed points of the original image. Use the `trueMatrix()` function to retrieve the actual matrix used for transforming an image.

See also:
  `trueMatrix()`, and Image Transformations.

### transformed

    public final QImage transformed(QMatrix matrix,
                                    Qt.TransformationMode mode)

  Returns a copy of the image that is transformed using the given transformation `matrix` and transformation `mode`.

  The transformation `matrix` is internally adjusted to compensate for unwanted translation; i.e. the image produced is the smallest image that contains all the transformed points of the original image. Use the `trueMatrix()` function to retrieve the actual matrix used for transforming an image.

See also:
  `trueMatrix()`, and Image Transformations.

### transformed

    public final QImage transformed(QTransform matrix)

  Returns a copy of the image that is transformed using the given transformation `matrix` and transformation `mode`.

  The transformation `matrix` is internally adjusted to compensate for unwanted translation; i.e. the image produced is the smallest image that contains all the transformed points of the original image. Use the `trueMatrix()` function to retrieve the actual matrix used for transforming an image.

  Unlike the other overload, this function can be used to perform perspective transformations on images.

See also:
  `trueMatrix()`, and Image Transformations.

### transformed

    public final QImage transformed(QTransform matrix,
                                    Qt.TransformationMode mode)

  Returns a copy of the image that is transformed using the given transformation `matrix` and transformation `mode`.

  The transformation `matrix` is internally adjusted to compensate for unwanted translation; i.e. the image produced is the smallest image that contains all the transformed points of the original image. Use the `trueMatrix()` function to retrieve the actual matrix used for transforming an image.

  Unlike the other overload, this function can be used to perform perspective transformations on images.

See also:
  `trueMatrix()`, and Image Transformations.

### valid

    public final boolean valid(QPoint pt)

  Returns true if `pos` is a valid coordinate pair within the image; otherwise returns false.

See also:
  `rect()`, and `QRect::contains()`.

### valid

    public final boolean valid(int x,
                               int y)

  Returns true if `QPoint`(`x`, `y`) is a valid coordinate pair within the image; otherwise returns false.

### width

    public final int width()

  Returns the width of the paint device in default coordinate system units (e. . pixels for `QPixmap` and `QWidget`).

See also:
  `widthMM()`.

  Specified by:
    `width` in interface `QPaintDeviceInterface`

### widthMM

    public final int widthMM()

  Returns the width of the paint device in millimeters.

See also:
  `width()`.

  Specified by:
    `widthMM` in interface `QPaintDeviceInterface`

### metric

    public int metric(QPaintDevice.PaintDeviceMetric metric)

  Returns the metric information for the given paint device `metric`.

See also:
  `PaintDeviceMetric` .

  Specified by:
    `metric` in interface `QPaintDeviceInterface`

### paintEngine

    public QPaintEngine paintEngine()

  Returns a pointer to the paint engine used for drawing on the device.

  Specified by:
    `paintEngine` in interface `QPaintDeviceInterface`

### trueMatrix

    public static QMatrix trueMatrix(QMatrix arg__1,
                                     int w,
                                     int h)

  Returns the actual matrix used for transforming an image with the given `width`, `height` and `matrix`.

  When transforming an image using the `transformed()` function, the transformation matrix is internally adjusted to compensate for unwanted translation, i.e. `transformed()` returns the smallest image containing all transformed points of the original image. This function returns the modified matrix, which maps points correctly from the original image into the new image.

See also:
  `transformed()`, and Image Transformations.

### trueMatrix

    public static QTransform trueMatrix(QTransform arg__1,
                                        int w,
                                        int h)

  Returns the actual matrix used for transforming an image with the given `width`, `height` and `matrix`.

  When transforming an image using the `transformed()` function, the transformation matrix is internally adjusted to compensate for unwanted translation, i.e. `transformed()` returns the smallest image containing all transformed points of the original image. This function returns the modified matrix, which maps points correctly from the original image into the new image.

  Unlike the other overload, this function creates transformation matrices that can be used to perform perspective transformations on images.

See also:
  `transformed()`, and Image Transformations.

### copyOfBytes

    public final byte[] copyOfBytes()

  Returns a copy of the image data.

  Returns:

### save

    public final boolean save(java.lang.String fileName,
                              java.lang.String format,
                              int quality)

  Saves the image to the file with the given `fileName`, using the given image file `format` and `quality` factor. If `format` is null, QImage will attempt to guess the format by looking at `fileName`'s suffix.

  The `quality` factor must be in the range 0 to 100 or -1. Specify 0 to obtain small compressed files, 100 for large uncompressed files, and -1 (the default) to use the default settings.

  Returns true if the image was successfully saved; otherwise returns false.

### save

    public final boolean save(java.lang.String fileName,
                              java.lang.String format)

  This is an overloaded method provided for convenience.

### save

    public final boolean save(java.lang.String fileName)

  This is an overloaded method provided for convenience.

### save

    public final boolean save(QIODevice dev,
                              java.lang.String format,
                              int quality)

  This is an overloaded method provided for convenience.

### save

    public final boolean save(QIODevice dev,
                              java.lang.String format)

  This is an overloaded method provided for convenience.

### save

    public final boolean save(QIODevice dev)

  This is an overloaded function provided for convenience.

### load

    public final boolean load(java.lang.String fileName,
                              java.lang.String format)

  Loads an image from the file with the given `fileName`. Returns true if the image was successfully loaded; otherwise returns false.

  The loader attempts to read the image using the specified `format`. If the `format` is null, the loader probes the file for a header to guess the file format.

  The file name can either refer to an actual file on disk or to one of the application's embedded resources. See the \l{resources.html}{Resource System} overview for details on how to embed images and other resource files in the application's executable.

### load

    public final boolean load(java.lang.String fileName)

  This is an overloaded method provided for convenience.

### load

    public final boolean load(QIODevice device,
                              java.lang.String format)

  This is an overloaded function provided for convenience.

### load

    public final boolean load(QIODevice device)

  This is an overloaded method provided for convenience.

### loadFromData

    public final boolean loadFromData(byte[] data,
                                      java.lang.String format)

  Loads an image from the given `QByteArray` `data`.

### loadFromData

    public final boolean loadFromData(byte[] data)

  Loads an image from the given `QByteArray` `data`.

### loadFromData

    public final boolean loadFromData(QByteArray data,
                                      java.lang.String format)

  This is an overloaded method provided for convenience.

### loadFromData

    public final boolean loadFromData(QByteArray data)

  This is an overloaded method provided for convenience.

### fromData

    public static QImage fromData(QByteArray data,
                                  java.lang.String format)

  This is an overloaded method provided for convenience.

  Loads an image from the given QByteArray `data`.

### fromData

    public static QImage fromData(QByteArray data)

  This is an overloaded method provided for convenience.

  Loads an image from the given QByteArray `data`.

### clone

    public QImage clone()

  This method is reimplemented for internal reasons

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD